{*******************************************************}
{                                                       }
{  VG Library II                                        }
{                                                       }
{  Demo Application                                     }
{                                                       }
{  (c) 1997, 2000 by Vladimir Gaitanoff                 }
{                                                       }
{*******************************************************}

{$I vg2.inc}

unit fmControls;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  fmChild, vg2PropStore, ComCtrls, Buttons, StdCtrls, ExtCtrls,
  vg2FileCtrls, vg2ListCombo, vg2StdCtrls, vg2DateCtrls, vg2CalcCtrls,
  vg2Tools, vg2ExtCtrls, vg2Buttons;

type
  TControlsForm = class(TChildForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet5: TTabSheet;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    PageControl2: TPageControl;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    cmTvg2DriveComboBox: TSpeedButton;
    cmTvg2DirectoryListBox: TSpeedButton;
    cmTvg2FileListBox: TSpeedButton;
    cmTvg2FilterComboBox: TSpeedButton;
    vg2DirectoryListBox1: Tvg2DirectoryListBox;
    vg2DriveComboBox1: Tvg2DriveComboBox;
    vg2FileListBox1: Tvg2FileListBox;
    vg2FilterComboBox1: Tvg2FilterComboBox;
    cmTvg2DirectoryTreeView: TSpeedButton;
    vg2DirectoryTreeView1: Tvg2DirectoryTreeView;
    vg2FileListBox2: Tvg2FileListBox;
    TabSheet9: TTabSheet;
    vg2FilterComboBox2: Tvg2FilterComboBox;
    c1Tvg2FilterComboBox: TSpeedButton;
    c1Tvg2FileListBox: TSpeedButton;
    Label1: TLabel;
    cmTvg2FolderEdit: TSpeedButton;
    cmTvg2FileNameEdit: TSpeedButton;
    edFileEdit: Tvg2FileNameEdit;
    edFolderEdit: Tvg2FolderEdit;
    Label2: TLabel;
    Label3: TLabel;
    rgBrowse: TRadioGroup;
    dlBrowse: Tvg2BrowseFolderDialog;
    cmTvg2BrowseFolderDialog: TSpeedButton;
    cmBrowseTest: TButton;
    Label4: TLabel;
    TabSheet10: TTabSheet;
    cmTvg2LaunchLabel: TSpeedButton;
    cmTvg2Launcher: TSpeedButton;
    cmTvg2VersionInfo: TSpeedButton;
    vg2LaunchLabel1: Tvg2LaunchLabel;
    Label5: TLabel;
    edLaunchFile: Tvg2FileNameEdit;
    cmLaunch: TButton;
    lnLaunch: Tvg2Launcher;
    Label6: TLabel;
    Label7: TLabel;
    GroupBox4: TGroupBox;
    chBtn1: TCheckBox;
    chBtn2: TCheckBox;
    cbGlyph1: TComboBox;
    cbGlyph2: TComboBox;
    Label8: TLabel;
    cbExpand: TComboBox;
    PageControl3: TPageControl;
    TabSheet11: TTabSheet;
    TabSheet12: TTabSheet;
    cmTvg2Edit: TSpeedButton;
    edEdit: Tvg2Edit;
    TabSheet13: TTabSheet;
    cmTvg2SpinEdit: TSpeedButton;
    edSpinEdit: Tvg2SpinEdit;
    cmTvg2DateTimeEdit: TSpeedButton;
    edDateEdit: Tvg2DateTimeEdit;
    TabSheet14: TTabSheet;
    clClock: Tvg2Clock;
    cmTvg2Clock: TSpeedButton;
    Label9: TLabel;
    Label10: TLabel;
    deAlarmTime: Tvg2DateTimeEdit;
    Label11: TLabel;
    cmSetAlarm: TButton;
    rgAlarmStyle: TRadioGroup;
    Label12: TLabel;
    rgTextAlign: TRadioGroup;
    Label13: TLabel;
    edPicture: Tvg2Edit;
    Memo1: TMemo;
    cmTvg2MonthCalendar: TSpeedButton;
    clCalendar: Tvg2MonthCalendar;
    Label14: TLabel;
    Label15: TLabel;
    rgDateDisplay: TRadioGroup;
    egSpinDisplay: TRadioGroup;
    rgSpinOr: TRadioGroup;
    TabSheet15: TTabSheet;
    cmTvg2CalculatorEdit: TSpeedButton;
    edCalcEdit: Tvg2CalculatorEdit;
    rgSpinDir: TRadioGroup;
    edSpinDecimals: Tvg2SpinEdit;
    Label16: TLabel;
    edSpinIncr: Tvg2SpinEdit;
    Label17: TLabel;
    clCalc: Tvg2Calculator;
    cmTvg2Calculator: TSpeedButton;
    edCalcMon: Tvg2Edit;
    Label18: TLabel;
    edCalcDecimals: Tvg2SpinEdit;
    Label19: TLabel;
    Label20: TLabel;
    PageControl4: TPageControl;
    TabSheet16: TTabSheet;
    TabSheet17: TTabSheet;
    cmTvg2ListBox: TSpeedButton;
    cmTvg2ComboBox: TSpeedButton;
    cmTvg2ColorComboBox: TSpeedButton;
    cmTvg2FontComboBox: TSpeedButton;
    cbFont: Tvg2FontComboBox;
    meFont: TMemo;
    bgColor: Tvg2Background;
    cbColor1: Tvg2ColorComboBox;
    cbColor2: Tvg2ColorComboBox;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    chColorNames: TCheckBox;
    rgFontTypes: TRadioGroup;
    rgFontDevice: TRadioGroup;
    Label24: TLabel;
    lbListBox: Tvg2ListBox;
    cbComboBox: Tvg2ComboBox;
    GroupBox5: TGroupBox;
    chRowSelect: TCheckBox;
    chIndent: TCheckBox;
    chImages: TCheckBox;
    chFont: TCheckBox;
    chBkgnd: TCheckBox;
    Label25: TLabel;
    GroupBox6: TGroupBox;
    Label26: TLabel;
    PageControl5: TPageControl;
    TabSheet18: TTabSheet;
    cmTvg2Label: TSpeedButton;
    TabSheet19: TTabSheet;
    cmTvg2Background: TSpeedButton;
    TabSheet20: TTabSheet;
    cmTvg2Animator: TSpeedButton;
    vg2Animator1: Tvg2Animator;
    vg2AboutPanel1: Tvg2AboutPanel;
    cmTvg2AboutPanel: TSpeedButton;
    bgBack: Tvg2Background;
    Label27: TLabel;
    Label28: TLabel;
    cbGrad1: Tvg2ColorComboBox;
    cbGrad2: Tvg2ColorComboBox;
    rgGradDir: TRadioGroup;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    vgLabel3: Tvg2Label;
    vgLabel2: Tvg2Label;
    lb: Tvg2Label;
    vgLabel5: Tvg2Label;
    vgLabel4: Tvg2Label;
    TabSheet6: TTabSheet;
    cmTvg2Button: TSpeedButton;
    cmTvg2CheckBox: TSpeedButton;
    cmTvg2RadioButton: TSpeedButton;
    cmButton: Tvg2Button;
    cmCheckBox: Tvg2CheckBox;
    cmRadioButton1: Tvg2RadioButton;
    cmRadioButton2: Tvg2RadioButton;
    cmTvg2RepeatButton: TSpeedButton;
    pgBar: TProgressBar;
    cmInc: Tvg2RepeatButton;
    cmDec: Tvg2RepeatButton;
    rgTextAlignment: TRadioGroup;
    rgLayout: TRadioGroup;
    GroupBox7: TGroupBox;
    chPushButton: TCheckBox;
    Bevel1: TBevel;
    Label32: TLabel;
    Label33: TLabel;
    TabSheet4: TTabSheet;
    vg2SimplePanel1: Tvg2SimplePanel;
    vg2Splitter1: Tvg2Splitter;
    vg2SimplePanel2: Tvg2SimplePanel;
    Memo2: TMemo;
    Memo3: TMemo;
    vg2SimplePanel3: Tvg2SimplePanel;
    cmTvg2Splitter: TSpeedButton;
    Label34: TLabel;
    vg2Splitter2: Tvg2Splitter;
    procedure rgBrowseClick(Sender: TObject);
    procedure cmBrowseTestClick(Sender: TObject);
    procedure cmLaunchClick(Sender: TObject);
    procedure rgAlarmStyleClick(Sender: TObject);
    procedure cmSetAlarmClick(Sender: TObject);
    procedure clClockAlarm(Sender: TObject);
    procedure edPictureButtonFirstClick(Sender: TObject);
    procedure rgTextAlignClick(Sender: TObject);
    procedure chBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cbExpandClick(Sender: TObject);
    procedure cbGlyph1Change(Sender: TObject);
    procedure rgDateDisplayClick(Sender: TObject);
    procedure edSpinDecimalsChange(Sender: TObject);
    procedure edSpinIncrChange(Sender: TObject);
    procedure rgSpinOrClick(Sender: TObject);
    procedure rgSpinDirClick(Sender: TObject);
    procedure egSpinDisplayClick(Sender: TObject);
    procedure edCalcDecimalsChange(Sender: TObject);
    procedure cbFontChange(Sender: TObject);
    procedure cbColor1Change(Sender: TObject);
    procedure chColorNamesClick(Sender: TObject);
    procedure rgFontTypesClick(Sender: TObject);
    procedure rgFontDeviceClick(Sender: TObject);
    procedure chRowSelectClick(Sender: TObject);
    procedure lbListBoxGetItemIndent(Sender: TObject; Index: Integer;
      var Indent: Integer);
    procedure lbListBoxGetItemParams(Sender: TObject; Index: Integer;
      State: TOwnerDrawState; AFont: TFont; var Background: TColor;
      var ImageIndex, StateIndex, OverlayIndex: Integer);
    procedure cbGrad1Change(Sender: TObject);
    procedure rgGradDirClick(Sender: TObject);
    procedure cmIncClick(Sender: TObject);
    procedure rgTextAlignmentClick(Sender: TObject);
    procedure rgLayoutClick(Sender: TObject);
    procedure chPushButtonClick(Sender: TObject);
    procedure edPictureButtonSecondClick(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateListControls;
  public
    { Public declarations }
  end;

implementation
uses TypInfo, dmMain, vg2MaskDs;

{$R *.DFM}

procedure TControlsForm.FormShow(Sender: TObject);

  procedure AddItems(Items: TStrings);
  var
    I: Integer;
    S: string;
  begin
    Items.BeginUpdate;
    try
      for I := 0 to dm.ilImages.Count - 1 do
      begin
        S := Format('Image number %d', [I]);
        Items.Add(S);
      end;
    finally
      Items.EndUpdate;
    end;
  end;

  procedure GetGlyphs(Items: TStrings);
  var
    I: TEditButtonGlyphKind;
  begin
    for I := Low(I) to High(I) do
      Items.Add(Copy(GetEnumName(TypeInfo(TEditButtonGlyphKind), ord(I)), 3, MaxInt));
  end;

begin
  inherited;
  cbExpand.ItemIndex := 1;
  GetGlyphs(cbGlyph1.Items);
  cbGlyph1.ItemIndex := 0;
  GetGlyphs(cbGlyph2.Items);
  cbGlyph2.ItemIndex := 0;
  edPictureButtonFirstClick(nil);
  cbFontChange(nil);
  AddItems(lbListBox.Items);
  AddItems(cbComboBox.Items);
  UpdateListControls;
end;

procedure TControlsForm.rgAlarmStyleClick(Sender: TObject);
begin
  clClock.ShowStyle := TClockShowStyle(rgAlarmStyle.ItemIndex);
end;

procedure TControlsForm.cmSetAlarmClick(Sender: TObject);
begin
  clClock.AlarmTime := deAlarmTime.Time;
  clClock.AlarmEnabled := True;
end;

procedure TControlsForm.clClockAlarm(Sender: TObject);
begin
  MessageBeep(0);
  ShowMessage('Alarm!');
end;

procedure TControlsForm.rgBrowseClick(Sender: TObject);
begin
  edFolderEdit.BrowseKind := TBrowseFolderKind(rgBrowse.ItemIndex);
  dlBrowse.BrowseKind := TBrowseFolderKind(rgBrowse.ItemIndex);
end;

procedure TControlsForm.cmBrowseTestClick(Sender: TObject);
begin
  dlBrowse.Execute;
end;

procedure TControlsForm.cmLaunchClick(Sender: TObject);
begin
  lnLaunch.FileName := edLaunchFile.FileName;
  lnLaunch.Execute;
end;

procedure TControlsForm.edPictureButtonFirstClick(Sender: TObject);
begin
  edEdit.Picture.PictureMask := edPicture.Text;
end;

procedure TControlsForm.edPictureButtonSecondClick(Sender: TObject);
begin
  psStore.AppIniFile.BeginRead;
  try
    if EditPicture(edEdit.Picture, psStore.AppIniFile.IniFile) then
      edPicture.Text := edEdit.Picture.PictureMask;
  finally
    psStore.AppIniFile.EndRead;
  end;
end;

procedure TControlsForm.rgTextAlignClick(Sender: TObject);
var
  Alignment: TAlignment;
begin
  Alignment := TAlignment(rgTextAlign.ItemIndex);
  edEdit.Alignment := Alignment;
  edSpinEdit.Alignment := Alignment;
  edCalcEdit.Alignment := Alignment;
  edDateEdit.Alignment := Alignment;
end;

procedure TControlsForm.chBtn1Click(Sender: TObject);
var
  Value1, Value2: Boolean;
begin
  Value1 := chBtn1.Checked;
  Value2 := chBtn2.Checked;
  edEdit.Buttons[btFirst].Visible := Value1;
  edEdit.Buttons[btSecond].Visible := Value2;
  edSpinEdit.Buttons[btFirst].Visible := Value1;
  edSpinEdit.Buttons[btSecond].Visible := Value2;
  edCalcEdit.Buttons[btSecond].Visible := Value2;
  edDateEdit.Buttons[btSecond].Visible := Value2;
end;

procedure TControlsForm.cbExpandClick(Sender: TObject);
var
  Value: TExpandMode;
begin
  Value := TExpandMode(cbExpand.ItemIndex);
  edEdit.ExpandMode := Value;
  edSpinEdit.ExpandMode := Value;
  edCalcEdit.ExpandMode := Value;
  edDateEdit.ExpandMode := Value;
end;

procedure TControlsForm.cbGlyph1Change(Sender: TObject);
var
  Value1, Value2: TEditButtonGlyphKind;
begin
  Value1 := TEditButtonGlyphKind(cbGlyph1.ItemIndex);
  Value2 := TEditButtonGlyphKind(cbGlyph2.ItemIndex);
  edEdit.Buttons[btFirst].Kind := Value1;
  edEdit.Buttons[btSecond].Kind := Value2;
  edSpinEdit.Buttons[btFirst].Kind := Value1;
  edSpinEdit.Buttons[btSecond].Kind := Value2;
  edCalcEdit.Buttons[btSecond].Kind := Value2;
  edDateEdit.Buttons[btSecond].Kind := Value2;
end;

procedure TControlsForm.edCalcDecimalsChange(Sender: TObject);
begin
  edCalcEdit.Decimals := Round(edCalcDecimals.Position);
  clCalc.Decimals := Round(edCalcDecimals.Position);
end;

procedure TControlsForm.edSpinDecimalsChange(Sender: TObject);
begin
  edSpinEdit.Decimals := Round(edSpinDecimals.Position);
end;

procedure TControlsForm.edSpinIncrChange(Sender: TObject);
begin
  edSpinEdit.Increment := edSpinIncr.Position;
end;

procedure TControlsForm.rgSpinOrClick(Sender: TObject);
begin
  edSpinEdit.Orientation := TSpinOrientation(rgSpinOr.ItemIndex);
end;

procedure TControlsForm.rgSpinDirClick(Sender: TObject);
begin
  edSpinEdit.Direction := TSpinDirection(rgSpinDir.ItemIndex);
end;

procedure TControlsForm.egSpinDisplayClick(Sender: TObject);
begin
  edSpinEdit.DisplayValue := TSpinValueType(egSpinDisplay.ItemIndex);
end;

procedure TControlsForm.rgDateDisplayClick(Sender: TObject);
begin
  edDateEdit.DisplayValue := TDateTimeValueType(rgDateDisplay.ItemIndex);
end;

procedure TControlsForm.cbFontChange(Sender: TObject);
begin
  meFont.Font := cbFont.SelectedFont;
end;

procedure TControlsForm.cbColor1Change(Sender: TObject);
begin
  bgColor.GradientColorStart := cbColor1.SelectedColor;
  bgColor.GradientColorStop := cbColor2.SelectedColor;
end;

procedure TControlsForm.chColorNamesClick(Sender: TObject);
begin
  cbColor1.ShowColorNames := chColorNames.Checked;
  cbColor2.ShowColorNames := chColorNames.Checked;
end;

procedure TControlsForm.rgFontTypesClick(Sender: TObject);
begin
  cbFont.FontTypes := TFontTypes(rgFontTypes.ItemIndex);
end;

procedure TControlsForm.rgFontDeviceClick(Sender: TObject);
begin
  cbFont.FontDevice := TFontDevice(rgFontDevice.ItemIndex);
end;

procedure TControlsForm.UpdateListControls;
begin
  lbListBox.RowSelect := chRowSelect.Checked;
  cbComboBox.RowSelect := chRowSelect.Checked;
  if chImages.Checked then
  begin
    lbListBox.Images := dm.ilImages;
    cbComboBox.Images := dm.ilImages;
  end else begin
    lbListBox.Images := nil;
    cbComboBox.Images := nil;
  end;
  lbListBox.Invalidate;
  cbComboBox.Invalidate;
end;

procedure TControlsForm.chRowSelectClick(Sender: TObject);
begin
  UpdateListControls;
end;

procedure TControlsForm.lbListBoxGetItemIndent(Sender: TObject;
  Index: Integer; var Indent: Integer);
begin
  if chIndent.Checked then
    Indent := Index * 10 mod 50;
end;

type
  TControlHack = class(TControl);

procedure TControlsForm.lbListBoxGetItemParams(Sender: TObject;
  Index: Integer; State: TOwnerDrawState; AFont: TFont;
  var Background: TColor; var ImageIndex, StateIndex,
  OverlayIndex: Integer);
const
  Colors : array[0..10] of TColor = (
   clTeal, clGray, clSilver, clRed, clLime, clYellow, clBlue, clFuchsia, clAqua, clLtGray, clDkGray);

begin
  if chFont.Checked and (odSelected in State) then
    AFont.Style := AFont.Style + [fsBold] else
    AFont.Style := AFont.Style - [fsBold];
  if chBkgnd.Checked then
  begin
    if odSelected in State then
    begin
      Background := clHighlight;
    end else
      Background := Colors[Index mod (High(Colors) + 1)];
  end else begin
    if odSelected in State then
      Background := clHighlight else
      Background := TControlHack(Sender).Color;
  end;
end;

procedure TControlsForm.cbGrad1Change(Sender: TObject);
begin
  bgBack.GradientColorStart := cbGrad1.SelectedColor;
  bgBack.GradientColorStop := cbGrad2.SelectedColor;
end;

procedure TControlsForm.rgGradDirClick(Sender: TObject);
begin
  bgBack.GradientDirection := TGradientDirection(rgGradDir.ItemIndex);
end;

procedure TControlsForm.cmIncClick(Sender: TObject);
begin
  pgBar.Position := pgBar.Position + TComponent(Sender).Tag;
end;

procedure TControlsForm.rgTextAlignmentClick(Sender: TObject);
var
  Alignment: TAlignment;
begin
  Alignment := TAlignment(rgTextAlignment.ItemIndex);
  cmButton.TextAlignment := Alignment;
  cmCheckBox.TextAlignment := Alignment;
  cmRadioButton1.TextAlignment := Alignment;
  cmRadioButton2.TextAlignment := Alignment;
end;

procedure TControlsForm.rgLayoutClick(Sender: TObject);
var
  Layout: TTextLayout;
begin
  Layout := TTextLayout(rgLayout.ItemIndex);
  cmButton.Layout := Layout;
  cmCheckBox.Layout := Layout;
  cmRadioButton1.Layout := Layout;
  cmRadioButton2.Layout := Layout;
end;

procedure TControlsForm.chPushButtonClick(Sender: TObject);
var
  ButtonMode: TButtonMode;
begin
  ButtonMode := TButtonMode(chPushButton.Checked);
  cmCheckBox.ButtonMode := ButtonMode;
  cmRadioButton1.ButtonMode := ButtonMode;
  cmRadioButton2.ButtonMode := ButtonMode;
end;

end.
